<template>
	<v-container>
		<v-snackbar
			v-model="snack"
			:timeout="timeout"
			top
			color="green"
			class="subtitle-1"
		>Archivos subidos correctamente</v-snackbar>
		<v-snackbar v-model="snackEstudio" :timeout="3000" top color="orange" class="subtitle-1">No olvides hacer el estudio socioeconómico.</v-snackbar>
		<p class="text-center display-1">Subida de documentos</p>
		<v-form ref="FormUploadDocumentsNew" v-model="isValid">
			<!-- Para talento especial -->
			<v-row v-if="typeNewScholarship === 'Talento especial'">
				<v-col cols="12" sm="6" md="4" v-for="item of dataDocumentsTalent" :key="item.title">
					<v-card outlined>
						<v-card color="#c51f2f" height="60">
							<v-card-text>
								<p class="text-center white--text title">{{item.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{item.desc}}</p>
							<v-file-input
								:prepend-icon="item.icon"
								@change="handler($event,item.model)"
								show-size
								:rules="rulesDocuments"
								label="Selecciona un archivo"
								dense
								rounded
								outlined
								:accept="item.accept"
								required
							/>
						</v-card-text>
					</v-card>
				</v-col>
			</v-row>
			<!-- Para no talento especial -->
			<v-row v-else>
				<v-col cols="12" sm="6" md="4" v-for="item of dataDocuments" :key="item.title">
					<v-card outlined>
						<v-card color="#c51f2f" height="60">
							<v-card-text>
								<p class="text-center white--text title">{{item.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{item.desc}}</p>
							<v-file-input
								:prepend-icon="item.icon"
								@change="handler($event,item.model)"
								show-size
								:rules="rulesDocuments"
								label="Selecciona un archivo"
								dense
								rounded
								outlined
								:accept="item.accept"
								required
							/>
						</v-card-text>
					</v-card>
				</v-col>
			</v-row>
			<v-row justify="center" justify-sm="space-around">
				<v-col cols="12" sm="3">
					<v-btn color="blue" outlined block :to="{name:'AvailableScholarships'}">Atras</v-btn>
				</v-col>
				<v-col cols="12" sm="3">
					<v-btn
						:disabled="!isValid || uploaded"
						:loading="loading"
						outlined
						block
						color="green"
						@click="sendDocuments"
					>Subir documentos</v-btn>
				</v-col>
			</v-row>
		</v-form>
	</v-container>
</template>

<script>
import axios from "axios";
import { mapState, mapMutations } from "vuex";
import gql from "graphql-tag";
import EventBus from '../../bus';

export default {
	name: "FormUploadDocuments",
	data: () => ({
		isValid: true,
		uploaded: false,
		loading: false,
		snack: false,
		snackEstudio: true,
		timeout: 2000,
		typeNewScholarship: "",
		documentsTalent: {
			acta: {},
			ine: {},
			curp: {},
			carta: {},
			cv: {},
			kardex: {},
			const: {},
			comp: {},
			foto: {},
			reco: {}
		},
		documents: {
			acta: {},
			ine: {},
			curp: {},
			carta: {},
			cv: {},
			kardex: {},
			const: {},
			comp: {},
			foto: {}
		},
		dataDocumentsTalent: [
			{
				title: "Acta de nacimiento",
				desc: "Acta de nacimiento vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.acta"
			},
			{
				title: "INE",
				desc: "Credencial de elector vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.ine"
			},
			{
				title: "CURP",
				desc: "Clave Única de Registro de Población oficial.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.curp"
			},
			{
				title: "Carta de exposición de motivos",
				desc:
					"Una carta que exponga los motivos para solicitar la beca.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.carta"
			},
			{
				title: "Curriculum vitae",
				desc: "Documento con tu historial profesional.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.cv"
			},
			{
				title: "Kardex de calificaciones",
				desc: "Constancia de calificaciones generales.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.kardex"
			},
			{
				title: "Comprobante de inscripción",
				desc: "Constancia de estudios.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.const"
			},
			{
				title: "Comprobante de ingresos",
				desc: "Documento que avala los ingresos familiares.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.comp"
			},
			{
				title: "Fotografía de la casa",
				desc: "Fotografía frontal de la casa.",
				icon: "fas fa-camera",
				accept: "image/*",
				model: "documentsTalent.foto"
			},
			{
				title: "Premio nacional",
				desc: "Reconocimiento nacional vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.reco"
			}
		],
		dataDocuments: [
			{
				title: "Acta de nacimiento",
				desc: "Acta de nacimiento vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documents.acta"
			},
			{
				title: "INE",
				desc: "Credencial de elector vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documents.ine"
			},
			{
				title: "CURP",
				desc: "Clave Única de Registro de Población oficial.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documents.curp"
			},
			{
				title: "Carta de exposición de motivos",
				desc:
					"Una carta que exponga los motivos para solicitar la beca.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documents.carta"
			},
			{
				title: "Curriculum vitae",
				desc: "Documento con tu historial profesional.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documents.cv"
			},
			{
				title: "Kardex de calificaciones",
				desc: "Constancia de calificaciones generales.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documents.kardex"
			},
			{
				title: "Comprobante de inscripción",
				desc: "Constancia de estudios.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documents.const"
			},
			{
				title: "Comprobante de ingresos",
				desc: "Documento que avala los ingresos familiares.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documents.comp"
			},
			{
				title: "Fotografía de la casa",
				desc: "Fotografía frontal de la casa.",
				icon: "fas fa-camera",
				accept: "image/*",
				model: "documents.foto"
			}
		],
		rulesDocuments: [
			value => !!value || "Campo requerido",
			value =>
				!value ||
				value.size < 1000000 ||
				"El archivo no debe pesar mas de 1 mb"
		]
	}),
	computed: {
		...mapState(["userData"])
	},
	methods: {
		...mapMutations(["saveUserData"]),
		nameScholarship() {
			switch (this.$route.params.typeNewScholarship) {
				case "talento-especial":
					this.typeNewScholarship = "Talento especial";
					break;
				case "excelencia-académica":
					this.typeNewScholarship = "Excelencia académica";
					break;
				case "mejora-académica":
					this.typeNewScholarship = "Mejora académica";
					break;
				case "labsol":
					this.typeNewScholarship = "Labsol";
					break;
			}
		},
		// Evento que guarda el documento subido en cada variable
		handler(e, i) {
			this.saveUserData();
			if (this.typeNewScholarship === "Talento especial") {
				switch (i) {
					case "documentsTalent.acta":
						this.documentsTalent.acta = e;
						break;
					case "documentsTalent.ine":
						this.documentsTalent.ine = e;
						break;
					case "documentsTalent.curp":
						this.documentsTalent.curp = e;
						break;
					case "documentsTalent.carta":
						this.documentsTalent.carta = e;
						break;
					case "documentsTalent.cv":
						this.documentsTalent.cv = e;
						break;
					case "documentsTalent.kardex":
						this.documentsTalent.kardex = e;
						break;
					case "documentsTalent.const":
						this.documentsTalent.const = e;
						break;
					case "documentsTalent.comp":
						this.documentsTalent.comp = e;
						break;
					case "documentsTalent.foto":
						this.documentsTalent.foto = e;
						break;
					case "documentsTalent.reco":
						this.documentsTalent.reco = e;
						break;
				}
			} else if (this.typeNewScholarship !== "Talento especial") {
				switch (i) {
					case "documents.acta":
						this.documents.acta = e;
						break;
					case "documents.ine":
						this.documents.ine = e;
						break;
					case "documents.curp":
						this.documents.curp = e;
						break;
					case "documents.carta":
						this.documents.carta = e;
						break;
					case "documents.cv":
						this.documents.cv = e;
						break;
					case "documents.kardex":
						this.documents.kardex = e;
						break;
					case "documents.const":
						this.documents.const = e;
						break;
					case "documents.comp":
						this.documents.comp = e;
						break;
					case "documents.foto":
						this.documents.foto = e;
						break;
				}
			}
		},
		// Envia los documentos al servidor
		async sendDocuments() {
			// FormData para poder convertir los documentos obtenidos y enviarlos al server
			try {
				// codigo para talento especial
				if (this.typeNewScholarship === "Talento especial") {
					let formDataTalent = new FormData();

					const filesToUploadTalent = [
						{ file: this.documentsTalent.acta, name: "acta.pdf" },
						{ file: this.documentsTalent.ine, name: "ine.pdf" },
						{ file: this.documentsTalent.curp, name: "curp.pdf" },
						{ file: this.documentsTalent.carta, name: "carta.pdf" },
						{ file: this.documentsTalent.cv, name: "cv.pdf" },
						{
							file: this.documentsTalent.kardex,
							name: "kardex.pdf"
						},
						{ file: this.documentsTalent.const, name: "const.pdf" },
						{ file: this.documentsTalent.comp, name: "comp.pdf" },
						{ file: this.documentsTalent.foto, name: "photo.jpg" },
						{ file: this.documentsTalent.reco, name: "reco.pdf" }
					];
					for (let i of filesToUploadTalent) {
						formDataTalent.append("files", i.file, i.name);
					}
					// peticion que envia los archivos
					await axios.post("/uploadFiles/new", formDataTalent, {
						headers: {
							"Content-Type": "multipart/form-data",
							Authorization: `${sessionStorage.getItem("token")}`
						}
					});
					// mutation para agregar la beca al historial
					await this.$apollo.mutate({
						mutation: gql`
							mutation($curp: String!, $scholarship: String!) {
								addScholarship(
									curp: $curp
									scholarship: $scholarship
								)
							}
						`,
						variables: {
							curp: this.userData.curp,
							scholarship: this.typeNewScholarship
						}
					});
					this.loading = true;
					setTimeout(() => {
						this.snack = true;
						this.loading = false;
						this.uploaded = true;
						setTimeout(() => {
							EventBus.$emit('openFormEconomicStudy');
						},1000);
					}, 3000);
				}
				// codigo para beca que sea diferente a talento especial
				else if (this.typeNewScholarship !== "Talento especial") {
					let formData = new FormData();

					const filesToUpload = [
						{ file: this.documents.acta, name: "acta.pdf" },
						{ file: this.documents.ine, name: "ine.pdf" },
						{ file: this.documents.curp, name: "curp.pdf" },
						{ file: this.documents.carta, name: "carta.pdf" },
						{ file: this.documents.cv, name: "cv.pdf" },
						{ file: this.documents.kardex, name: "kardex.pdf" },
						{ file: this.documents.const, name: "const.pdf" },
						{ file: this.documents.comp, name: "comp.pdf" },
						{ file: this.documents.foto, name: "photo.jpg" }
					];
					for (let i of filesToUpload) {
						formData.append("files", i.file, i.name);
					}
					// peticion que envia los archivos
					await axios.post("/uploadFiles/new", formData, {
						headers: {
							Authorization: sessionStorage.getItem("token"),
							"Content-Type": "multipart/form-data"
						}
					});
					// mutation para agregar la beca al historial
					await this.$apollo.mutate({
						mutation: gql`
							mutation($scholarship: String!) {
								addScholarship(scholarship: $scholarship)
							}
						`,
						variables: {
							scholarship: this.typeNewScholarship
						}
					});
					this.loading = true;
					setTimeout(() => {
						this.snack = true;
						this.loading = false;
						this.uploaded = true;
						setTimeout(() => {
							EventBus.$emit('openFormEconomicStudy');
						},1000);
					}, 3000);
				}
			} catch (error) {}
		},
		// obtiene el status del estudio socioeconomico
		async getSocioeconomicStudy(){
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!){
							findStudent(curp: $curp){
								documents{
									socioeconomicStudy{
										status
									}
								}
							}
						}
					`,
					variables:{
						curp: this.userData.curp
					}
				});

				data.findStudent.documents === null ? this.snackEstudio = true : this.snackEstudio = false;
			} catch (error) {}
		}
	},
	created() {
		this.saveUserData();
		this.nameScholarship();
		this.getSocioeconomicStudy();
	}
};
</script>